<?php

namespace Idealcheckout\Payment\Model\Method;

class AbstractIdealcheckout extends \Magento\Payment\Model\Method\AbstractMethod
{
	    /**
     * Availability option
     *
     * @var bool
     */
    protected $_canCapturePartial = true;

    /**
     * Availability option
     *
     * @var bool
     */
    protected $_canRefund = true;

    /**
     * Availability option
     *
     * @var bool
     */
    protected $_canRefundInvoicePartial = true;
	
	protected $_objectManager;
	
	protected $_urlBuilder;
	
	/**
     * @var OrderSender
     */
	protected $orderSender;
	
	/**
     * @var invoiceSender
     */
	protected $invoiceSender;
	
	protected $scopeConfig;
	
	public function __construct(
        \Magento\Framework\Model\Context $context,
        \Magento\Framework\Registry $registry,
        \Magento\Framework\Api\ExtensionAttributesFactory $extensionFactory,
        \Magento\Framework\Api\AttributeValueFactory $customAttributeFactory,
        \Magento\Payment\Helper\Data $paymentData,
        \Magento\Framework\App\Config\ScopeConfigInterface $scopeConfig,
        \Magento\Payment\Model\Method\Logger $logger,
		\Magento\Framework\UrlInterface $urlBuilder,
		\Magento\Framework\ObjectManagerInterface $objectManager,
		\Magento\Sales\Model\Order\Email\Sender\OrderSender $orderSender,
		\Magento\Sales\Model\Order\Email\Sender\InvoiceSender $invoiceSender,
        \Magento\Framework\Model\ResourceModel\AbstractResource $resource = null,
        \Magento\Framework\Data\Collection\AbstractDb $resourceCollection = null,
		//\Psr\Log\LoggerInterface $logger,
        array $data = []		
    ) {
        parent::__construct(
            $context,
            $registry,
            $extensionFactory,
            $customAttributeFactory,
            $paymentData,
            $scopeConfig,
            $logger,
            $resource,
            $resourceCollection,
            $data
        );

		$this->_urlBuilder = $urlBuilder;
		$this->_objectManager = $objectManager;
		$this->_minAmount = 0;
        $this->_maxAmount = 100000;
		
		$this->orderSender = $orderSender;
		$this->invoiceSender = $invoiceSender;
		$this->scopeConfig = $scopeConfig;
		
		$this->_logger = $logger;
    }

	public function getOrderPlaceRedirectUrl()
	{
		return $this->_urlBuilder->getUrl('idealcheckout/payment/start');
	}

    /**
     * Availability for currency
     *
     * @param string $currencyCode
     * @return bool
     */
    public function canUseForCurrency($currencyCode)
    {
        return true;
    }
	
	public function refund(\Magento\Payment\Model\InfoInterface $payment, $amount)
    {
        $idealcheckout = $this->_objectManager->create('Idealcheckout\Payment\Model\Idealcheckout');
		$idealcheckout->amount = $amount;
		
		if($idealcheckout->RefundRequest($payment->getParentTransactionId()) < 0)
		{
			throw new \Magento\Framework\Exception\LocalizedException(
                'Idealcheckout Refund failed: ' . $ex
            );
		}
		
        return $this;
    }
}